#!/usr/bin/python

###
###
### This file is part of the CS-Rosetta Toolbox and is made available under
### GNU General Public License
### Copyright (C) 2011-2013 Oliver Lange
### email: oliver.lange@tum.de
### web: www.csrosetta.org
### version: 2.0
###
### This program is free software: you can redistribute it and/or modify
### it under the terms of the GNU General Public License as published by
### the Free Software Foundation, either version 3 of the License, or
### (at your option) any later version.
###
### This program is distributed in the hope that it will be useful,
### but WITHOUT ANY WARRANTY; without even the implied warranty of
### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
### GNU General Public License for more details.
###
### You should have received a copy of the GNU General Public License
### along with this program.  If not, see <http://www.gnu.org/licenses/>.
###
###

import sys
import os
import string


if len(sys.argv) < 2:
  print "Syntax: %s <silentfile> <columnname1> [  <columnname2> ... ]"%sys.argv[0]
  sys.exit(0)

file = open(sys.argv[1],"r")

#lines = string.split(file.read(),"\n")

showfilename = False;

names = []
for arg in sys.argv[2:]:
  if arg == "-f":
    showfilename = True
    continue
  names.append((arg,-1))

donetitles = False

for (i,(n,j)) in enumerate(names):
  names[i] = (string.lower(n), j)

if len(names)<=0:
  sys.stderr.write("Warning: not columns names supplied: defaulting to rms vs score\n")
  names.append( ("rms", -1) )
  names.append( ("score", -1) )


for l in file:
  token = string.split(l)
  if len(token) <= 0: continue
  ## SCORE LINE HEADERS
  #if not donetitles:
  if (token[0] == "SCORE ") or ((token[0] == "SCORE:") and (token[1] == "score")):
    ## look for names
    for ti,t in enumerate(token):
      for (i,(n,j)) in enumerate(names):
        if string.lower(t) == n:  ## if names match
          names[i] = (n,ti)  ## remember index

    Error = False
    for i,(n,j) in enumerate(names):
      if j < 0:
        sys.stderr.write("Error: Cannot find column named '%s' \n"%n)
        Error = True

    if Error: sys.exit(1)
    donetitles = True
    continue


  ## SCORE LINE
  if token[0] == "SCORE:":
    token = string.split(l)
    if showfilename: sys.stdout.write("%s "%sys.argv[1])
    for (n,i) in names:
      sys.stdout.write("%10s "%token[i])
    sys.stdout.write("\n")
